## purple-lurch 0.6.8+git20200527.388605

=== Makefile ===
### toolchain
#
CC ?= gcc

PKG_CONFIG ?= pkg-config
XML2_CONFIG ?= xml2-config
LIBGCRYPT_CONFIG ?= libgcrypt-config

MKDIR = mkdir
MKDIR_P = mkdir -p
INSTALL = install
INSTALL_LIB = $(INSTALL) -m 755
INSTALL_DIR = $(INSTALL) -d -m 755
RM = rm
RM_RF = $(RM) -rf
CMAKE ?= cmake
CMAKE_FLAGS = -DCMAKE_BUILD_TYPE=Debug -DCMAKE_C_FLAGS=-fPIC

### flags
#
GLIB_CFLAGS ?= $(shell $(PKG_CONFIG) --cflags glib-2.0)
GLIB_LDFLAGS ?= $(shell $(PKG_CONFIG) --libs glib-2.0)

LIBPURPLE_CFLAGS=$(shell $(PKG_CONFIG) --cflags purple)
PURPLE_DIR=$(shell $(PKG_CONFIG) --variable=plugindir purple)
LIBPURPLE_LDFLAGS=$(shell $(PKG_CONFIG) --cflags purple) \
		    -L$(PURPLE_DIR)
		    
XML2_CFLAGS ?= $(shell $(XML2_CONFIG) --cflags)
XML2_LDFLAGS ?= $(shell $(XML2_CONFIG) --libs)

LIBGCRYPT_LDFLAGS ?= $(shell $(LIBGCRYPT_CONFIG) --libs)

PKGCFG_C=$(GLIB_CFLAGS) \
	 $(LIBPURPLE_CFLAGS) \
	 $(XML2_CFLAGS)


PKGCFG_L=$(shell $(PKG_CONFIG) --libs sqlite3 mxml) \
 	$(GLIB_LDFLAGS) \
	 $(LIBPURPLE_LDFLAGS) \
	 $(XML2_LDFLAGS) \
	 $(LIBGCRYPT_LDFLAGS)

ifneq ("$(wildcard /etc/redhat-release)","")
	LJABBER= -lxmpp
else
ifneq ("$(wildcard /etc/SuSE-release)","")
	LJABBER= -lxmpp
else
	LJABBER= -ljabber
endif
endif

HEADERS=-I$(HDIR)/jabber -I$(LOMEMO_SRC) -I$(AXC_SRC) -I$(AX_DIR)/src
CFLAGS += -std=c11 -Wall -g -Wstrict-overflow $(PKGCFG_C) $(HEADERS)
PLUGIN_CPPFLAGS=-DPURPLE_PLUGINS
# -D_BSD_SOURCE can be removed once nobody uses glibc <= 2.18 any more
CPPFLAGS += -D_XOPEN_SOURCE=700 -D_BSD_SOURCE -D_DEFAULT_SOURCE
LDFLAGS += -ldl -lm $(PKGCFG_L) $(LJABBER) -Wl,-rpath,$(PURPLE_PLUGIN_DIR)
LDFLAGS_T=$(LDFLAGS) -lpurple -lcmocka 

### directories
#
PURPLE_HOME_PLUGIN_DIR=$(HOME)/.purple/plugins
PURPLE_PLUGIN_DIR = $(shell $(PKG_CONFIG) --variable=plugindir purple)

LDIR=./lib
BDIR=./build
SDIR=./src
HDIR=./headers
TDIR=./test

LOMEMO_DIR=$(LDIR)/libomemo
LOMEMO_SRC=$(LOMEMO_DIR)/src
LOMEMO_BUILD=$(LOMEMO_DIR)/build
LOMEMO_PATH=$(LOMEMO_BUILD)/libomemo-conversations.a

AXC_DIR=$(LDIR)/axc
AXC_SRC=$(AXC_DIR)/src
AXC_BUILD=$(AXC_DIR)/build
AXC_PATH=$(AXC_BUILD)/libaxc-nt.a

AX_DIR=$(AXC_DIR)/lib/libsignal-protocol-c
AX_PATH=$(AX_DIR)/build/src/libsignal-protocol-c.a

SOURCES := $(wildcard $(SDIR)/*.c)
OBJECTS := $(patsubst $(SDIR)/%.c, $(BDIR)/%.o, $(SOURCES))
OBJECTS_W_COVERAGE := $(patsubst $(SDIR)/%.c, $(BDIR)/%_w_coverage.o, $(SOURCES))
TEST_SOURCES := $(wildcard $(TDIR)/test_*.c)
TEST_OBJECTS := $(patsubst $(TDIR)/test_%.c, $(BDIR)/test_%.o, $(TEST_SOURCES))
TEST_TARGETS := $(patsubst $(TDIR)/test_%.c, $(BDIR)/test_%, $(TEST_SOURCES))
VENDOR_LIBS=$(LOMEMO_PATH) $(AXC_PATH) $(AX_PATH)


### make rules
#
all: $(BDIR)/lurch.so

$(BDIR):
	$(MKDIR_P) build

$(AX_PATH):
	cd $(AX_DIR)/ && \
	   $(MKDIR_P) build && \
	   cd build && \
	   $(CMAKE) $(CMAKE_FLAGS) .. \
	   && $(MAKE)

$(AXC_PATH):
	$(MAKE) -C "$(AXC_DIR)" build/libaxc-nt.a

$(LOMEMO_PATH):
	$(MAKE) -C "$(LOMEMO_DIR)" build/libomemo-conversations.a

$(BDIR)/%.o: $(SDIR)/%.c | $(BDIR)
	$(CC) -fPIC $(CFLAGS) $(CPPFLAGS) $(PLUGIN_CPPFLAGS) -c $(SDIR)/$*.c -o $@

$(BDIR)/%_w_coverage.o: $(SDIR)/%.c | $(BDIR)
	$(CC) -O0 --coverage $(CFLAGS) $(CPPFLAGS) $(PLUGIN_CPPFLAGS) -c $(SDIR)/$*.c -o $@

$(BDIR)/test_%.o: $(TDIR)/test_%.c | $(BDIR)
	$(CC) $(CFLAGS) -O0 -c $(TDIR)/test_$*.c -o $@

$(BDIR)/lurch.so: $(OBJECTS) $(VENDOR_LIBS)
	$(CC) -fPIC -shared $(CFLAGS) $(CPPFLAGS) $(PLUGIN_CPPFLAGS) \
		$^ \
		-o $@ $(LDFLAGS)
$(BDIR)/lurch.a: $(BDIR)/lurch.o $(VENDOR_LIBS)
	$(AR) rcs $@ $^

install: $(BDIR)/lurch.so
	[ -e "$(DESTDIR)/$(PURPLE_PLUGIN_DIR)" ] || \
		$(INSTALL_DIR) "$(DESTDIR)/$(PURPLE_PLUGIN_DIR)"
	$(INSTALL_LIB) "$(BDIR)/lurch.so" "$(DESTDIR)/$(PURPLE_PLUGIN_DIR)/lurch.so"

install-home: $(BDIR)/lurch.so
	[ -e "$(PURPLE_HOME_PLUGIN_DIR)" ] || \
		$(INSTALL_DIR) "$(PURPLE_HOME_PLUGIN_DIR)"
	$(INSTALL_LIB) "$(BDIR)/lurch.so" "$(PURPLE_HOME_PLUGIN_DIR)/lurch.so"


LURCH_VERSION ?= 0.0.0
TARBALL_DIR_NAME=lurch-$(LURCH_VERSION)
TARBALL_FILE_NAME=$(TARBALL_DIR_NAME)-src.tar.gz

tarball: | clean-all $(BDIR)
	$(MKDIR) $(TARBALL_DIR_NAME)
	rsync -av --progress . $(TARBALL_DIR_NAME)/ --exclude $(TARBALL_DIR_NAME)/ --exclude-from=.gitignore
	-find $(TARBALL_DIR_NAME)/ -name "*.git*" -exec rm -rf "{}" \;
	tar czf $(TARBALL_FILE_NAME) $(TARBALL_DIR_NAME)/
	mv $(TARBALL_FILE_NAME) $(TARBALL_DIR_NAME)/
	mv $(TARBALL_DIR_NAME) $(BDIR)/

$(BDIR)/test_lurch_util: $(OBJECTS_W_COVERAGE) $(VENDOR_LIBS) $(BDIR)/test_lurch_util.o
	$(CC) $(CFLAGS) $(CPPFLAGS) -O0 --coverage $^ $(PURPLE_DIR)/libjabber.so.0 -o $@ $(LDFLAGS_T) \
	-Wl,--wrap=purple_user_dir \
	-Wl,--wrap=purple_prefs_get_bool \
	-Wl,--wrap=purple_prefs_get_int \
	-Wl,--wrap=purple_debug_error \
	-Wl,--wrap=purple_debug_info \
	-Wl,--wrap=purple_debug_misc \
	-Wl,--wrap=purple_base16_encode_chunked
	bash -c "set -o pipefail; $@ 2>&1 | grep -Ev ".*CRITICAL.*" | tr -s '\n'" # filter annoying and irrelevant glib output

$(BDIR)/test_lurch_api: $(OBJECTS_W_COVERAGE) $(VENDOR_LIBS) $(BDIR)/test_lurch_api.o
	$(CC) $(CFLAGS) $(CPPFLAGS) -O0 --coverage $^ $(PURPLE_DIR)/libjabber.so.0 -o $@ $(LDFLAGS_T) \
	-Wl,--wrap=purple_account_get_username \
	-Wl,--wrap=purple_account_get_connection \
	-Wl,--wrap=purple_signal_register \
	-Wl,--wrap=purple_signal_unregister \
	-Wl,--wrap=purple_signal_connect \
	-Wl,--wrap=purple_signal_disconnect \
	-Wl,--wrap=purple_find_conversation_with_account \
	-Wl,--wrap=jabber_pep_publish \
	-Wl,--wrap=jabber_chat_find_by_conv \
	-Wl,--wrap=axc_get_device_id \
	-Wl,--wrap=axc_key_load_public_own \
	-Wl,--wrap=axc_key_load_public_addr \
	-Wl,--wrap=axc_session_exists_any \
	-Wl,--wrap=omemo_storage_user_devicelist_retrieve \
	-Wl,--wrap=omemo_storage_chatlist_delete \
	-Wl,--wrap=omemo_storage_chatlist_save \
	-Wl,--wrap=omemo_storage_chatlist_exists \
	-Wl,--wrap=omemo_storage_user_devicelist_retrieve \
	-Wl,--wrap=lurch_util_fp_get_printable
	bash -c "set -o pipefail; $@ 2>&1 | grep -Ev ".*CRITICAL.*" | tr -s '\n'" # filter annoying and irrelevant glib output

test: $(OBJECTS_W_COVERAGE) $(VENDOR_LIBS) $(TEST_TARGETS)

coverage: test
	gcovr -r . --html --html-details -o build/coverage.html
	gcovr -r . -s

clean:
	$(RM_RF) "$(BDIR)"

clean-all: clean
	$(MAKE) -C "$(LOMEMO_DIR)" clean
	$(MAKE) -C "$(AXC_DIR)" clean-all

.PHONY: clean clean-all install install-home tarball test coverage

=== debian/changelog ===
purple-lurch (0.6.8+git20200527.388605-3) unstable; urgency=medium

  [ Evangelos Ribeiro Tzaras ]
  * d/patches: Fix test failure on mipsel
  * d/patches: mention forwarded patches

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Thu, 29 Oct 2020 21:43:15 +0100

purple-lurch (0.6.8+git20200527.388605-2) unstable; urgency=medium

  * Updated VCS fields in d/control to point to the right repo
  * Added patch letting users know when message decryption failed
  * Included copyright for headers/jabber

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Sun, 14 Jun 2020 19:52:18 +0200

purple-lurch (0.6.8+git20200527.388605-1) unstable; urgency=medium

  * Initial release (Closes: #905883)

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Mon, 25 May 2020 16:58:35 +0200

=== debian/control ===
Source: purple-lurch
Priority: optional
Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
Uploaders:
 Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>,
Build-Depends:
 debhelper-compat (= 13),
 libaxc-dev,
 libcmocka-dev,
 libomemo-dev,
 libpurple-dev,
 libsignal-protocol-c-dev,
 libxml2-dev,
Standards-Version: 4.5.0
Section: net
Homepage: https://github.com/gkdr/lurch
Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/purple-lurch
Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/purple-lurch.git
Rules-Requires-Root: no

Package: purple-lurch
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: XEP-0384 OMEMO Encryption plugin for libpurple
 OMEMO is an XMPP Extension Protocl (XEP) for secure multi-client
 end-to-end encryption. It is based on Double Ratched and PEP.
 .
 This package contains the plugin for libpurple clients.

## purple-lurch 0.7.0

=== Makefile ===
--- 
+++ 
@@ -25,22 +25,48 @@
 PURPLE_DIR=$(shell $(PKG_CONFIG) --variable=plugindir purple)
 LIBPURPLE_LDFLAGS=$(shell $(PKG_CONFIG) --cflags purple) \
 		    -L$(PURPLE_DIR)
-		    
+
+LIBOMEMO_CFLAGS = $(shell $(PKG_CONFIG) --cflags libomemo)
+LIBOMEMO_LDFLAGS = $(shell $(PKG_CONFIG) --libs libomemo)
+
+LIBAXC_CFLAGS = $(shell $(PKG_CONFIG) --cflags libaxc)
+LIBAXC_LDFLAGS = $(shell $(PKG_CONFIG) --libs libaxc)
+
+LIBSIGNAL_PROTOCOL_CFLAGS = $(shell $(PKG_CONFIG) --cflags libsignal-protocol-c)
+LIBSIGNAL_PROTOCOL_LDFLAGS = $(shell $(PKG_CONFIG) --cflags libsignal-protocol-c)
+
 XML2_CFLAGS ?= $(shell $(XML2_CONFIG) --cflags)
 XML2_LDFLAGS ?= $(shell $(XML2_CONFIG) --libs)
 
 LIBGCRYPT_LDFLAGS ?= $(shell $(LIBGCRYPT_CONFIG) --libs)
+
+USE_DYNAMIC_LIBS=libsignal-protocol-c libaxc libomemo
+USE_DYNAMIC_LIBS:=$(shell pkg-config --exists $(USE_DYNAMIC_LIBS) && \
+	echo '$(USE_DYNAMIC_LIBS)')
 
 PKGCFG_C=$(GLIB_CFLAGS) \
 	 $(LIBPURPLE_CFLAGS) \
 	 $(XML2_CFLAGS)
 
+ifneq ($(USE_DYNAMIC_LIBS),)
+	PKGCFG_C+=$(LIBOMEMO_CFLAGS) \
+	 $(LIBAXC_CFLAGS) \
+	 $(LIBSIGNAL_PROTOCOL_CFLAGS)
+endif
+
 
 PKGCFG_L=$(shell $(PKG_CONFIG) --libs sqlite3 mxml) \
- 	$(GLIB_LDFLAGS) \
+	 $(GLIB_LDFLAGS) \
 	 $(LIBPURPLE_LDFLAGS) \
 	 $(XML2_LDFLAGS) \
 	 $(LIBGCRYPT_LDFLAGS)
+
+ifneq ($(USE_DYNAMIC_LIBS),)
+	PKGCFG_L+=$(LIBOMEMO_LDFLAGS) \
+	 $(LIBAXC_LDFLAGS) \
+	 $(LIBSIGNAL_PROTOCOL_LDFLAGS)
+endif
+
 
 ifneq ("$(wildcard /etc/redhat-release)","")
 	LJABBER= -lxmpp
@@ -52,13 +78,17 @@
 endif
 endif
 
-HEADERS=-I$(HDIR)/jabber -I$(LOMEMO_SRC) -I$(AXC_SRC) -I$(AX_DIR)/src
+ifeq ($(USE_DYNAMIC_LIBS),)
+	HEADERS=-I$(HDIR)/jabber -I$(LOMEMO_SRC) -I$(AXC_SRC) -I$(AX_DIR)/src
+else
+	HEADERS=-I$(HDIR)/jabber
+endif
 CFLAGS += -std=c11 -Wall -g -Wstrict-overflow $(PKGCFG_C) $(HEADERS)
 PLUGIN_CPPFLAGS=-DPURPLE_PLUGINS
 # -D_BSD_SOURCE can be removed once nobody uses glibc <= 2.18 any more
 CPPFLAGS += -D_XOPEN_SOURCE=700 -D_BSD_SOURCE -D_DEFAULT_SOURCE
 LDFLAGS += -ldl -lm $(PKGCFG_L) $(LJABBER) -Wl,-rpath,$(PURPLE_PLUGIN_DIR)
-LDFLAGS_T=$(LDFLAGS) -lpurple -lcmocka 
+LDFLAGS_T=$(LDFLAGS) -lpurple -lcmocka
 
 ### directories
 #
@@ -84,14 +114,15 @@
 AX_DIR=$(AXC_DIR)/lib/libsignal-protocol-c
 AX_PATH=$(AX_DIR)/build/src/libsignal-protocol-c.a
 
-SOURCES := $(wildcard $(SDIR)/*.c)
+SOURCES := $(sort $(wildcard $(SDIR)/*.c))
 OBJECTS := $(patsubst $(SDIR)/%.c, $(BDIR)/%.o, $(SOURCES))
 OBJECTS_W_COVERAGE := $(patsubst $(SDIR)/%.c, $(BDIR)/%_w_coverage.o, $(SOURCES))
-TEST_SOURCES := $(wildcard $(TDIR)/test_*.c)
+TEST_SOURCES := $(sort $(wildcard $(TDIR)/test_*.c))
 TEST_OBJECTS := $(patsubst $(TDIR)/test_%.c, $(BDIR)/test_%.o, $(TEST_SOURCES))
 TEST_TARGETS := $(patsubst $(TDIR)/test_%.c, $(BDIR)/test_%, $(TEST_SOURCES))
-VENDOR_LIBS=$(LOMEMO_PATH) $(AXC_PATH) $(AX_PATH)
-
+ifeq ($(USE_DYNAMIC_LIBS),)
+	VENDOR_LIBS=$(LOMEMO_PATH) $(AXC_PATH) $(AX_PATH)
+endif
 
 ### make rules
 #
@@ -167,6 +198,7 @@
 	$(CC) $(CFLAGS) $(CPPFLAGS) -O0 --coverage $^ $(PURPLE_DIR)/libjabber.so.0 -o $@ $(LDFLAGS_T) \
 	-Wl,--wrap=purple_account_get_username \
 	-Wl,--wrap=purple_account_get_connection \
+	-Wl,--wrap=purple_connection_get_protocol_data \
 	-Wl,--wrap=purple_signal_register \
 	-Wl,--wrap=purple_signal_unregister \
 	-Wl,--wrap=purple_signal_connect \
@@ -174,6 +206,7 @@
 	-Wl,--wrap=purple_find_conversation_with_account \
 	-Wl,--wrap=jabber_pep_publish \
 	-Wl,--wrap=jabber_chat_find_by_conv \
+	-Wl,--wrap=jabber_iq_send \
 	-Wl,--wrap=axc_get_device_id \
 	-Wl,--wrap=axc_key_load_public_own \
 	-Wl,--wrap=axc_key_load_public_addr \

=== debian/changelog ===
purple-lurch (0.7.0-2ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:17:36 +1100

purple-lurch (0.7.0-2ubuntu2) noble; urgency=medium

  * Strip -Werror=implicit-function-declaration from CFLAGS.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 24 Mar 2024 10:34:04 +0100

purple-lurch (0.7.0-2ubuntu1) noble; urgency=medium

  * Fix shlibs.local file for t64 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 24 Mar 2024 00:05:51 +0100

purple-lurch (0.7.0-2build2) noble; urgency=high

  * No change rebuild against libpurple0t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:49:38 +0100

purple-lurch (0.7.0-2build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 06:44:59 +0000

purple-lurch (0.7.0-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository, Repository-Browse.

  [ Evangelos Ribeiro Tzaras ]
  * docs: Install upstream README; Closes: #989590 (thanks Paul Wise)

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Thu, 13 Jul 2023 11:30:41 +0200

purple-lurch (0.7.0-1) unstable; urgency=medium

  * Declare compliance with Debian Policy 4.6.1
  * gbp.conf: Use sane defaults and document usage
  * Remove upstreamed patches
  * Update build dependencies
  * Update copyright
  * Add copyright helper script
  * Remove obsolete lintian override
  * Add libmxml-dev build dependency; Closes: #1013525 (thanks Lucas Nussbaum)
  * Add custom-library-search-path lintian override for purple dir RUNPATH

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Sat, 28 May 2022 21:32:43 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,21 @@
 Source: purple-lurch
 Priority: optional
-Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
 Uploaders:
  Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>,
 Build-Depends:
  debhelper-compat (= 13),
  libaxc-dev,
  libcmocka-dev,
+ libgcrypt-dev,
+ libmxml-dev,
  libomemo-dev,
  libpurple-dev,
  libsignal-protocol-c-dev,
+ libsqlite3-dev,
  libxml2-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Section: net
 Homepage: https://github.com/gkdr/lurch
 Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/purple-lurch

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_STRIP = -Werror=implicit-function-declaration

%:
	dh $@

=== debian/tests/control ===
Test-Command: make test
Depends:
 libgcrypt20-dev,
 libmxml-dev,
 libsqlite3-dev,
 @,
 @builddeps@,
Restrictions: allow-stderr
